routes/web.php
<?php

use App\Http\Controllers\ProfileController;
use App\Http\Controllers\MessagesController;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\UsersController;
use App\Http\Controllers\RolesController;
use App\Http\Controllers\TagsController;
use App\Http\Controllers\NotesController;

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::get('test', function() {

    return \App\Models\User::with('mensajes')->get();
});

Route::get('/', 'App\Http\Controllers\MessagesController@create')->name('mensajes.index');

Route::middleware(['auth'])->group(function () {

    Route::resource('usuarios', UsersController::class);
    Route::put('usuarios-cambiaestado/{id}','App\Http\Controllers\UsersController@cambiaEstado')->name('usuarios.estado');   
    
    Route::resource('mensajes', MessagesController::class);
    Route::get('mensajes/pdf', 'App\Http\Controllers\MessagesController@pdf')->name('mensajes.pdf');   
    
    Route::get('mensajes-exportar', 'App\Http\Controllers\MessagesController@export')->name('mensajes.export');
    Route::get('mensajes-importar', 'App\Http\Controllers\MessagesController@import')->name('mensajes.import');
    Route::post('mensajes-importar', 'App\Http\Controllers\MessagesController@import')->name('mensajes.import');
    
    Route::resource('roles', RolesController::class);
    Route::put('roles-cambiaestado/{id}','App\Http\Controllers\RolesController@cambiaEstado')->name('roles.estado');
    
    Route::resource('tags', TagsController::class);
    Route::resource('notas', NotesController::class);
    
    Route::get('componentes', 'App\Http\Controllers\PagesController@componentes')->name('componentes');
    
});


Route::get('documentacion', 'App\Http\Controllers\PagesController@docu')->name('docu');


//AJAX
Route::get('/get-nueva-nota', 'PrtiController@getClasificacionesCGCombo');

//******************************************************************************* */

Auth::routes();

app/Models/Role.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Role extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'display_name',
        'description',
        'active'        
    ];

    public function users() {
        return $this->hasMany(User::class, 'assigned_roles','role_id','user_id');
    }
}

app/Http/Controllers/RolesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Role;

class RolesController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $roles = Role::all()->sortBy('id');
        return view('roles.index', compact('roles'));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $rol = new Role;
       
        return view('roles.create', compact('rol'));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        $this->validate($request,[
            'name' => 'required',
            'display_name' => 'required'            
        ]);
        
        // $rol = new Role;
        // $rol->name = $request->name;
        // $rol->display_name = $request->display_name;
        // $rol->description = $request->description;
        // $rol->save();

        Role::create($request->all());

        return redirect()->back()->with('info','Rol agregado');
    }

    /**
     * Display the specified resource.
     */
    public function show(string $id)
    {
        $rol = Role::findorFail($id);

        return view('roles.show',compact('rol'));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(string $id)
    {
        $rol = Role::findorFail($id);

        return view('roles.edit', compact('rol'));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, string $id)
    {
        $this->validate($request, [
            'name' => 'required',
            'display_name' => 'required'                      
        ]);

        $rol = Role::findorFail($id);

        $rol->update($request->all());

        return redirect()->back()->with('info','Rol actualizado');

    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(string $id)
    {
        $rol = Role::findorFail($id)->delete();

        return redirect()->back()->with('info','Rol eliminado');
    }

    public function cambiaEstado($id) { 
        
        $active = !Role::findorFail($id)->active;      

        Role::findorFail($id)->update([
            'active' => $active
        ]);

        return redirect()->back();
    }
}

resources/views/roles/create.blade.php
@extends('adminlte::page')

@section('title', 'Crear Rol')

@section('content_header')
    <h1 class=" col-6 alert alert-info">Nuevo Rol</h1>
@stop


@section('content')

    @if (Session()->has('info'))
        <div class="alert alert-success">{{ Session('info')}}</div>
    @endif

    <form action="{{ route('roles.store') }}" method="POST">        
        {!! csrf_field() !!}             
    @include('roles.fields', ['rol' => $rol, 'btnText'=> 'Grabar'])
    </form>

@endsection

resources/views/roles/edit.blade.php
@extends('adminlte::page')

@section('title', 'Editar Rol')

@section('content_header')
    <h1 class="text-center alert alert-info">Bienvenido a mensajes 😎✉</h1>
@stop


@section('content')    

    @if (Session()->has('info'))
    <div class="alert alert-success">{{ Session('info')}}</div>
    @endif

    <form action="{{route('roles.update',$rol->id)}}" method="post">
        {!!method_field('PUT')!!}
        {!! csrf_field() !!}    
        @include('roles.fields', ['rol' => $rol, 'btnText' => 'Actualizar'])
    </form>

@endsection

resources/views/roles/fields.blade.php
<div class="form-group col-6">
    <label class="form-label" for="name">Nombre </label>
    <input class="form-control" type="text" name="name" id="name" value="{{ $rol->name ?? old('name') }}"/>
    @if ($errors->first('name'))
        <span class="alert alert-danger btn btn-sm">{{ $errors->first('name') }}</span> 
    @endif                              
</div>

<div class="form-group col-6">
    <label class="form-label" for="display_name"> Rol </label>
    <input class="form-control" autocomplete="true" type="display_name" name="display_name" id="display_name" value="{{ $rol->display_name ?? old('display_name') }}"/>
    @if ($errors->first('display_name'))
        <span class="alert alert-danger btn btn-sm"> {{ $errors->first('display_name') }}</span>
    @endif
</div>

<div class="form-group col-6">
    <label class="form-label" for="description"> Descripcion </label>
    <input class="form-control" autocomplete="true" type="description" name="description" id="description" value="{{ $rol->description ?? old('description') }}"/>
    @if ($errors->first('description'))
        <span class="alert alert-danger btn btn-sm"> {{ $errors->first('description') }}</span>
    @endif
</div> 

<div class="col-6">
    <button type="submit" class="btn btn-success btn-md">{{ $btnText }}</button>
</div>

resources/views/roles/index.blade.php
@extends('adminlte::page')

@section('title', 'Roles')

@section('content_header')
    <h1 class="text-center alert alert-info">Modulo de Roles</h1>
@stop

@section('content')

@if (Session()->has('info'))
    <div class="alert alert-success"> {{Session('info')}}</div>
@endif

<table class="table table-striped table-hover text-center">    
    <thead>
        <tr class="table-info">
            <th>ID</th>
            <th>Nombre</th>
            <th>Rol Name</th>
            <th>Descripcion</th>
            <th>Acciones</th>
                       
        </tr>
    </thead>

    <tbody>       

        @foreach ($roles as $r)
            <tr>
                <td>{{ $r->id }}</td>
                <td>{{ $r->name }}</td>
                <td>{{ $r->display_name }}</td>
                <td>{{ $r->description }}</td>                
                <td>
                    <a class="btn btn-info btn-sm" href="{{ route('roles.show',$r->id)}}">Ver</a>
                    <a class="btn btn-warning btn-sm" href="{{ route('roles.edit',$r->id)}}">Editar</a>
                    <form action="{{ route('roles.destroy',$r->id)}}" method="post" class="d-inline">
                        {!!method_field('DELETE')!!}
                        {!! csrf_field() !!}
                        <button class="btn btn-danger btn-sm" type="submit">Eliminar</button>
                    </form>
                   
                    <form action="{{ route('roles.estado',$r->id)}}" method="post" class="d-inline">
                        {!!method_field('PUT')!!}
                        {!! csrf_field() !!}
                        <button class="{{ $r->active ? 'btn btn-info btn-sm' : 'btn btn-danger btn-sm' }}" type="submit">{{ $r->active ? 'Activo' : 'Inactivo' }}</button>
                    </form>
                   
                </td>           
               
            </tr>
                    
        @endforeach
    
    </tbody>
</table>

@endsection

resources/views/roles/show.blade.php
@extends('adminlte::page')

@section('title', 'Ver Rol')

@section('content')

<div class="card">
    <div class="card-title text-left alert alert-info">
         Ver Rol 👥
    </div>
       
    <div class="card-body">
       
        <div class="row">

            <div class="col-xs-12 col-sm-12 col-md-12">

                <table class="table table-striped table-hover table-bordered">
                    <tbody>
                        <tr> 
                            <td><strong>Nombre</strong></td>
                            <td> {{ $rol->name }}</td>
                        </tr>

                        <tr> 
                            <td><strong>Alias</strong></td>
                            <td> {{ $rol->display_name }}</td>
                        </tr>

                        <tr> 
                            <td><strong>Descripcion</strong></td>
                            <td> {{ $rol->description }}</td>
                        </tr>

                        <tr> 
                            <td><strong>Activo</strong></td>
                            <td> {{ $rol->active ? '✅' : '❌' }}</td>
                        </tr>                        

                    </tbody>
                </table>
               

            </div>

        </div>

    </div>
</div>

@endsection